//
//  AppController.m
//  iWrite
//
//  Created by Stephen Ross on 28/05/2009.
//  Copyright 2009 Forth Valley College. All rights reserved.
//

#import "AppController.h"
#import "PreferenceController.h"

@implementation AppController

+ (void)initialize
{
	NSMutableDictionary *defaultValues = [NSMutableDictionary dictionary];
	
	NSData *colorAsData = [NSKeyedArchiver archivedDataWithRootObject:[NSColor whiteColor]];
	NSData *textColorAsData = [NSKeyedArchiver archivedDataWithRootObject:[NSColor blackColor]];
	
	[defaultValues setObject:colorAsData forKey:BNRTextViewBgColorKey];
	[defaultValues setObject:textColorAsData forKey:BNRTextViewTextColorKey];
	[defaultValues setObject:[NSNumber numberWithBool:YES] forKey:BNREmptyDocKey];
	
	[[NSUserDefaults standardUserDefaults] registerDefaults:defaultValues];
	
	NSLog(@"registered defaults: %@", defaultValues);
}

- (IBAction)showPreferencePanel:(id)sender
{
	if (!preferenceController) {
		preferenceController = [[PreferenceController alloc] init];
	}
	NSLog(@"showing %@", preferenceController);
	[preferenceController showWindow:self];
}

- (BOOL)applicationShouldOpenUntitledFile:(NSApplication *)sender
{
	NSLog(@"applicationShouldOpenUntitledFil:");
	
	return [[NSUserDefaults standardUserDefaults] boolForKey:BNREmptyDocKey];
}

@end
