//
//  MyDocument.m
//  iWrite
//
//  Created by Stephen Ross on 27/05/2009.
//  Copyright Forth Valley College 2009 . All rights reserved.
//

#import "MyDocument.h"
#import "PreferenceController.h"

@implementation MyDocument

- (id)init
{
    self = [super init];
    if (self) {
    
    }
	
	if (mString == nil) {
		mString =[[NSAttributedString alloc] initWithString:@""];
	}
	
    return self;
}

- (NSString *)windowNibName
{
    // Override returning the nib file name of the document
    // If you need to use a subclass of NSWindowController or if your document supports multiple NSWindowControllers, you should remove this method and override -makeWindowControllers instead.
    return @"MyDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController
{
    [super windowControllerDidLoadNib:aController];
	
	[textView setRulerVisible:YES];
	
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	NSData *colorAsData;
	colorAsData = [defaults objectForKey:BNRTextViewBgColorKey];
	
	[textView setBackgroundColor:[NSKeyedUnarchiver unarchiveObjectWithData:colorAsData]];
	
	NSUserDefaults *textDefaults = [NSUserDefaults standardUserDefaults];
	NSData *textColorAsData;
	textColorAsData = [textDefaults objectForKey:BNRTextViewTextColorKey];
	
	[textView setTextColor:[NSKeyedUnarchiver unarchiveObjectWithData:textColorAsData]];
	
	if ([self string] != nil) {
		[[textView textStorage] setAttributedString:[self string]];
	}
	
}

- (NSData *)dataOfType:(NSString *)typeName error:(NSError **)outError
{
    NSData *data;
	[self setString:[textView textStorage]];
	data = [NSArchiver archivedDataWithRootObject:[self string]];
	return data;
}

- (BOOL)readFromData:(NSData *)data ofType:(NSString *)typeName error:(NSError **)outError
{
    NSAttributedString *tempString = [NSUnarchiver unarchiveObjectWithData:data];
	[self setString:tempString];
	return YES;
}

- (NSAttributedString *)string
{
	return [[mString retain] autorelease];
}

- (void)setString:(NSAttributedString *)newValue
{
	if (mString != newValue) {
		if (mString) [mString release];
		mString = [newValue copy];
	}
}

- (void)textDidChange:(NSNotification *)notification
{
	[self setString:[textView textStorage]];
}

@end
